<script type="text/html" data-help-name="dim-xml-cmd-server">
  <p>
    A DIM-XML Server node providing a Command/Acknowledge service.<br>
    It sends an acknowledgement <i>as soon as</i> it receives a command.
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>
      The command received.<br>
      It is a JavaScript object containing the command parameters. One possible
      property of this object can be <code>$textContent</code> containing the
      single parameter or the text content of the command.
    </dd>
    <dt class="optional">key<span class="property-type">number</span></dt>
    <dd>
      An optional integer used for matching acknowledgements with commands.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a <i>Command/Acknoledge</i> service on a DIM Name
    Server (DNS). A connection to the DNS Server is required for this purpose,
    which can be created by clicking on the pencil icon or selecting an
    existing one shared between several DIM-XML nodes.
  </p>
  <p>
    The service is identified by the <i>Service Name</i> which must be unique
    for a given DNS Server and comply the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>part *( "/" part )</b>
      <br>part = (ALPHA / DIGIT) *body
      <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    For example:
    <pre>/command/name/test</pre>
  </p>
  <p>
    The node sends an acknowledgement to the client whether the command has
    been received correctly or not. In particular:
    <table style="outline-width:#888 solid thin">
      <tr style="background-color:#f8f8f8">
        <th width="50px">Ack</th>
        <th width="50px">Status</th>
        <th width="50px">Error</th>
      </tr>
      <tr style="background-color:#e8e8e8">
        <td><center>POSITIVE</center></td>
        <td><center><i>2</i></center></td>
        <td><center><i>0</i></center></td>
      </tr>
      <tr style="background-color:#f8f8f8">
        <td><center>NEGATIVE</center></td>
        <td><center><i>3</i></center></td>
        <td><center><i>-1</i></center></td>
      </tr>
    </table>
  </p>
</script>

<script type="text/html" data-help-name="dim-xml-cmd in">
  <p>
    A DIM-XML Server node providing a Command/Acknowledge service.<br>
    It <i>postpones</i> the sending of the acknowledgement to a possible
    execution of the command received.
  </p>
  <h3>Outputs</h3>
  <dl class="message-properties">
    <dt>payload<span class="property-type">object</span></dt>
    <dd>
      The command received.<br>
      It is a JavaScript object containing the command parameters. One possible
      property of this object can be <code>$textContent</code> containing the
      single parameter or the text content of the command.
    </dd>
    <dt class="optional">key<span class="property-type">number</span></dt>
    <dd>
      An optional integer used for matching acknowledgements to commands.
    </dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      The CMD response object. This property should not be used directly; it
      will be used by a DIM-XML CMD Response to send an acknowledgement to the
      client.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node registers a <i>Command/Acknoledge</i> service on a DIM Name
    Server (DNS). A connection to the DNS Server is required for this purpose,
    which can be created by clicking on the pencil icon or selecting an
    existing one shared between several DIM-XML nodes.
  </p>
  <p>
    The service is identified by the <i>Service Name</i> which must be unique
    for a given DNS Server and comply the following
    <a target="_blank" href="https://www.rfc-editor.org/info/rfc5234">
      abnf syntax
    </a>:
    <pre><b>part *( "/" part )</b>
      <br>part = (ALPHA / DIGIT) *body
      <br>body = (ALPHA / DIGIT / "-" / "+" / "_" / "." / ":")</pre>
    For example:
    <pre>/command/name/test</pre>
  <p>
    <b>Note</b>: This node does not send any acknowledgement to the DIM-XML CMD
    Client. The flow must include a <code>DIM-XML CMD Response</code> node to
    notify the client about the outcome of the command execution.
  </p>
</script>

<script type="text/html" data-help-name="dim-xml-cmd-response">
  <p>
    A DIM-XML node for sending a command acknowledgement to client that triggered
    the service.
  </p>
  <h3>Inputs</h3>
  <dl class="message-properties">
    <dt>
      payload
      <span class="property-type">string | number | boolean</span>
    </dt>
    <dd>The acknowledgement text content to be sent back. If this property is
      not set, no acknowledgement will be sent.</dd>
    <dt class="optional">error<span class="property-type">number</span></dt>
    <dd>
      An optional integer used to reject the command with a given error code.
      If not set, a successful acknowledgement is sent.
    </dd>
    <dt>res<span class="property-type">object</span></dt>
    <dd>
      This is necessary for sending the response to the client and <b>must</b>
      come from a <code>DIM-XML CMD Input</code> node.
    </dd>
  </dl>
  <h3>Details</h3>
  <p>
    This node is meant to return the result of command execution to a DIM-XML
    CMD Client, allowing an intermediate processing stage.
  </p>
  <p>
    It must be used in conjunction with a <code>DIM-XML CMD Input</code> node
    since it needs the <code>msg.res</code> property created by the latter in
    order to notify the requesting client.
  </p>
  <p>
    When an <code>error</code> code is provided as input to this node, the
    <code>payload</code> property should give a description of it.
  </p>
  <p>
    <b>Note</b>: It is <i>RECOMMENDED</i> to map negative <code>error</code>
    numbers to POSIX errno values.
  </p>
</script>
